/*************************************************************************************************/
/*       3                                          */
/*  ----------------------------------------------------										 */
/*    															 */
/*  .  																 */
/*    																	 */
/*  ----------------------------------------------------										 */
/*  : .  															 */
/*																								 */
/*  (c) - 2004                                                               */
/*                                                                                               */
/*************************************************************************************************/

#define MESSAGES_BACKGROUND_COLOR RGB(200,0,0)
#define CHARTS_BACKGROUND_COLOR RGB (128,128,128)
#define GRAPHICS_BACKGROUND_COLOR RGB (0,0,0)

#define TIMEOUT 1000000
#define INTERVAL 50
#define SPEED 10

#define CHART_SIZE 180
#define SCALEY 600

#include <windows.h>
#include <commctrl.h> 
#include <commdlg.h>
#include <stdio.h>
#include <stdlib.h>


#include "Resource.h"
#include "Mass.h"
#include "SerialComm.h"
#include "OpenGLWndEngine.h"

struct APPDATA
{
	short int mass;
	short int air;
	short int x;
	short int y;
	short int z;
	unsigned int DELAY;
	BOOL full_screen;
	BOOL debug_mode;
	BOOL game_mode;

	int Global_Time;
	BOOL Time_Running;
	BOOL IOThreadActive;
	BOOL IOComPorts;
	BOOL run;
	int counter;

	float kp;
	float kd;
	float ki;

	float kp2;
	float kd2;
	float ki2;

	float kp3;
	float kd3;
	float ki3;

	int comno;
	BOOL D3DView;
	BOOL OpenGLInitialized;
};

int xpos[CHART_SIZE];
int ypos[CHART_SIZE];
int zpos[CHART_SIZE];
int xptr,yptr,zptr;
int chinc;

HINSTANCE hInst;  
LPCTSTR lpszAppName ="MASSSIM";		
LPCTSTR lpszTitle="    (Ver 1.0) -    ()"; 

HWND MainAppWnd;		//     
HWND MessagesWnd;		//   
HWND ChartsWnd;  		//      
HWND GraphicsWnd;	    //        

HANDLE IOThread;

struct APPDATA data={10,5,200,200,100,500,TRUE,TRUE,TRUE,0,FALSE,FALSE,FALSE,FALSE,0,
					 4,1,0.02,
					 4,1,0.02,
					 4,1,0.02,
					 1,FALSE,FALSE};	//         

struct MESSAGE_WND_DATA;

class CMass Mass;
class CSerialComm Com;

class COpenGLWndEngine Engine;
HGLRC rc;
HDC dc;

int APIENTRY WinMain (HINSTANCE hInstance,HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd);
HWND MyCreateWindow(HWND hParentWindow,HINSTANCE hInst,char * ClassName,WNDPROC callback, DWORD Style,COLORREF back_color);
HWND MyCreateIndependentWindow(HWND hParentWindow,HINSTANCE hInst,char * ClassName,WNDPROC callback, DWORD Style,COLORREF back_color,char *Title);

LRESULT CALLBACK WndProc (HWND hWnd,UINT uMsg,WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK MessagesWndProc (HWND hWnd,UINT uMsg,WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK ChartsWndProc (HWND hWnd,UINT uMsg,WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK GraphicsWndProc (HWND hWnd,UINT uMsg,WPARAM wParam, LPARAM lParam);

BOOL CALLBACK About (HWND hDlg,UINT uMsg,WPARAM wParam, LPARAM lParam);
BOOL CALLBACK Parameters (HWND hDlg,UINT uMsg,WPARAM wParam, LPARAM lParam);

VOID CALLBACK MyTimer(HWND hwnd,UINT uMsg,UINT idEvent,DWORD dwTime);

DWORD WINAPI IOThreadFunc(LPVOID params);
void UpdateMessages(int Column);